var _excluded = ["visible", "value", "list", "allowClear", "multiple", "onSelect", "onBeforeChange", "onChange", "defaultPickerValue", "slotProps"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import DragList from "./utils/DragList";
import getIndex from "./utils/getIndex";

// 内库使用
import { formatList } from "./../../Select/utils";

// 测试使用
// import { formatList } from 'seedsui-react/lib/Select/utils'

var Main = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var visible = _ref.visible,
    value = _ref.value,
    list = _ref.list,
    allowClear = _ref.allowClear,
    multiple = _ref.multiple,
    onSelect = _ref.onSelect,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    defaultPickerValue = _ref.defaultPickerValue,
    slotProps = _ref.slotProps,
    props = _objectWithoutProperties(_ref, _excluded);
  // 过滤非法数据
  // eslint-disable-next-line
  list = formatList(list);

  // 节点
  var mainRef = useRef(null);
  var slotRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: mainRef.current,
      getRootDOM: function getRootDOM() {
        return mainRef.current;
      },
      update: update
    };
  });
  useEffect(function () {
    var dragList = DragList({
      container: mainRef.current,
      cellSize: 44,
      slotHeight: (list.length - 1) * 44,
      slot: slotRef.current,
      onDragEnd: function onDragEnd(_ref2) {
        var index = _ref2.index;
        onChange && onChange([list[index]]);
      }
    });
    dragList.events('removeEventListener');
    dragList.events('addEventListener');
    // eslint-disable-next-line
  }, []);
  useEffect(function () {
    if (visible && Array.isArray(value) && value.length) {
      update();
    }
    // eslint-disable-next-line
  }, [value]);

  // 更新视图
  function update() {
    var y = -getIndex(value, list) * 44;
    slotRef.current.style.transform = "translateY(".concat(y, "px)");
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "picker-main".concat(props.className ? ' ' + props.className : ''),
    ref: mainRef
  }), /*#__PURE__*/React.createElement("div", {
    className: "picker-layer"
  }, /*#__PURE__*/React.createElement("div", {
    className: "picker-layer-frame"
  })), /*#__PURE__*/React.createElement("div", {
    className: "picker-slotbox"
  }, /*#__PURE__*/React.createElement("ul", {
    ref: slotRef,
    className: "picker-slot text-center"
  }, (list || []).map(function (item, index) {
    return /*#__PURE__*/React.createElement("li", {
      key: item.id || index
    }, item.name);
  }))));
});
export default Main;